/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	"time"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_bootstrap/bootstrap/v1beta1"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-bootstrap/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KubeadmConfigsGetter has a method to return a KubeadmConfigInterface.
// A group's client should implement this interface.
type KubeadmConfigsGetter interface {
	KubeadmConfigs(namespace string) KubeadmConfigInterface
}

// KubeadmConfigInterface has methods to work with KubeadmConfig resources.
type KubeadmConfigInterface interface {
	Create(ctx context.Context, kubeadmConfig *v1beta1.KubeadmConfig, opts v1.CreateOptions) (*v1beta1.KubeadmConfig, error)
	Update(ctx context.Context, kubeadmConfig *v1beta1.KubeadmConfig, opts v1.UpdateOptions) (*v1beta1.KubeadmConfig, error)
	UpdateStatus(ctx context.Context, kubeadmConfig *v1beta1.KubeadmConfig, opts v1.UpdateOptions) (*v1beta1.KubeadmConfig, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.KubeadmConfig, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.KubeadmConfigList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.KubeadmConfig, err error)
	KubeadmConfigExpansion
}

// kubeadmConfigs implements KubeadmConfigInterface
type kubeadmConfigs struct {
	client rest.Interface
	ns     string
}

// newKubeadmConfigs returns a KubeadmConfigs
func newKubeadmConfigs(c *BootstrapV1beta1Client, namespace string) *kubeadmConfigs {
	return &kubeadmConfigs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the kubeadmConfig, and returns the corresponding kubeadmConfig object, and an error if there is any.
func (c *kubeadmConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.KubeadmConfig, err error) {
	result = &v1beta1.KubeadmConfig{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KubeadmConfigs that match those selectors.
func (c *kubeadmConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.KubeadmConfigList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.KubeadmConfigList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kubeadmConfigs.
func (c *kubeadmConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a kubeadmConfig and creates it.  Returns the server's representation of the kubeadmConfig, and an error, if there is any.
func (c *kubeadmConfigs) Create(ctx context.Context, kubeadmConfig *v1beta1.KubeadmConfig, opts v1.CreateOptions) (result *v1beta1.KubeadmConfig, err error) {
	result = &v1beta1.KubeadmConfig{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeadmConfig).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a kubeadmConfig and updates it. Returns the server's representation of the kubeadmConfig, and an error, if there is any.
func (c *kubeadmConfigs) Update(ctx context.Context, kubeadmConfig *v1beta1.KubeadmConfig, opts v1.UpdateOptions) (result *v1beta1.KubeadmConfig, err error) {
	result = &v1beta1.KubeadmConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		Name(kubeadmConfig.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeadmConfig).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *kubeadmConfigs) UpdateStatus(ctx context.Context, kubeadmConfig *v1beta1.KubeadmConfig, opts v1.UpdateOptions) (result *v1beta1.KubeadmConfig, err error) {
	result = &v1beta1.KubeadmConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		Name(kubeadmConfig.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeadmConfig).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the kubeadmConfig and deletes it. Returns an error if one occurs.
func (c *kubeadmConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kubeadmConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched kubeadmConfig.
func (c *kubeadmConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.KubeadmConfig, err error) {
	result = &v1beta1.KubeadmConfig{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("kubeadmconfigs").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
